TEMPLATE = app
DEPENDPATH += . src
INCLUDEPATH += .
CONFIG += thread
RESOURCES += glop.qrc
QT += xml
QT += network

#choose a compilation mode in release, debug or profil
#intermediate files .o or .moc will be stored in different directories
CONFIG += release

#compilation configuration
#console is useful when testing, but shoud not be used for the final release
win32 {
	DEFINES += WINDOWS
	RC_FILE = glopico.rc
	CONFIG += static
	CONFIG += console
}

unix {
	DEFINES += LINUX
	CONFIG += static
}

macx {
	DEFINES += MACX
	CONFIG += x86 ppc
	CONFIG += static
}

CONFIG(debug, debug|release) {
	OBJECTS_DIR += debugTmp
	MOC_DIR += debugTmp
	RCC_DIR += debugTmp
	TARGET = bin/glop_debug
} else {
	OBJECTS_DIR += releaseTmp
	MOC_DIR += releaseTmp
	RCC_DIR += releaseTmp
	TARGET = bin/glop
}

#this flag can be used to debug binaries in release mode
#QMAKE_CXXFLAGS_RELEASE += -g

profil {
	CONFIG += debug
	QMAKE_CXXFLAGS_DEBUG += -pg
	QMAKE_LFLAGS_DEBUG += -pg
	TARGET = bin/glop_profil
	OBJECTS_DIR = profilTmp
	MOC_DIR = profilTmp
	RCC_DIR = profilTmp
}

# Input
HEADERS += src/global.h \
           src/stringconverter.h \
           src/interface.h \
           src/basegame.h \
           src/basenode.h \
		   src/traversal.h \
           src/moveordering.h \
           src/game.h \
           src/nodestore.h \
           src/node/winlossnode.h \
           src/node/nimbernode.h \
           src/node/fulltreeinfo.h \
           src/node/fulltreenode.h \
           src/node/rct.h \
           src/node/rctmiserenode.h \
           src/sprouts/sproutsglobal.h \
           src/sprouts/representation.h \
           src/sprouts/boundary.h \
           src/sprouts/regionspr.h \
           src/sprouts/land.h \
           src/sprouts/position.h \
           src/board/board.h \
           src/board/crambase.h \
           src/board/cram.h \
           src/gameglobal.h \
           src/database.h \
           src/databasebutton.h \
           src/trace.h \
           src/tracewidget.h \
           src/widgetpopup.h \
           src/interfacewidget.h \
           src/glopwidget.h \
           src/error.h
SOURCES += src/stringconverter.cpp \
           src/stringconverter_test.cpp \
           src/basenode.cpp \
           src/moveordering.cpp \
           src/nodestore.cpp \
		   src/traversal.cpp \
           src/mainloop.cpp \
           src/basegame.cpp \
           src/interface.cpp \
           src/node/winlossnode.cpp \
           src/node/nimbernode.cpp \
           src/node/fulltreeinfo.cpp \
           src/node/fulltreenode.cpp \
           src/node/rct.cpp \
           src/node/rctmiserenode.cpp \
           src/game.cpp \
           src/sprouts/sproutsglobal.cpp \
           src/sprouts/representation.cpp \
           src/sprouts/boundary.cpp \
           src/sprouts/regionspr.cpp \
           src/sprouts/land.cpp \
           src/sprouts/position.cpp \
           src/board/board.cpp \
           src/board/crambase.cpp \
           src/board/cram.cpp \
           src/gameglobal.cpp \
           src/trace.cpp \
           src/tracewidget.cpp \
           src/widgetpopup.cpp \
           src/interfacewidget.cpp \
           src/glopwidget.cpp \
           src/database.cpp \
           src/databasebutton.cpp \
           src/glop.cpp \
           src/error.cpp
