/***************************************************************************
 *   Copyright (C) 2006-2011 by Julien Lemoine, Simon Viennot              *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <QApplication>
#include <time.h>
#include "glopwidget.h"

void main_help();
void main_test();
void main_testsuite();
void main_error();
void main_graphic(int argc, char **argv );

int main( int argc, char **argv ) {
	srand(time(NULL));	//initialisation so that rand() won't give always the same values
	string s;
	switch(argc) {
	  case 2 : s=(string) argv[1];
		if     (s=="-h" || s=="--help")  main_help();
		else if(s=="-t" || s=="--test")  main_test();
		else if(s=="--testStringConverter")  main_testsuite();
		#ifdef MACX
		//special hack for mac platform (there is a program id parameter when run on double-click)
		else if (s.substr(0,4)=="-psn")  main_graphic(argc, argv);
		#endif	
		else                             main_error();
		break;
	  case 1 :
		main_graphic(argc, argv);
		break;
	  default :
		main_error();
	}
	
	return EXIT_SUCCESS;
}

//Qt graphical interface
void main_graphic(int argc, char **argv ) {
	QApplication a( argc, argv );
	GlopWidget *hm = new GlopWidget();
	hm->show();
	a.exec();
}

//available options in command line
void main_help() {
	cout << "Available options for Glop :" << endl << endl
	     << "nothing        :" << "  " << "start graphical interface" << endl
	     << "-h or --help   :" << "  " << "print this help list" << endl
	     << "-t or --test   :" << "  " << "test function without interface (used for test)" << endl
	     << "--testStringConverter :" << "  " << "test suite to check StringConverter" << endl;
}

//unavailable parameter
void main_error(){
	cout << "This parameter is not valid." << endl
	     << "Use option \"-h\" or \"--help\" to print a list of available parameters." << endl;
}

//Function used sometimes to test a particular part of Glop
void main_test(){
	
}

//Test suite for StringConverter
void StringConverterTest();
void main_testsuite(){
	StringConverterTest();
}
